/*------------------------------------------------------------------------*/
/*  (Dubois, Jullien, Magnac)  */
/*------------------------------------------------------------------------*/
/* Janvier 2005 */

#delimit ; 
pause on; set more 1 ;
set matsize 10000 ; clear ; set mem 200m ;
cd c:/pakistan/travail ;
sysdir set PERSONAL C:\STATA\ado\personal\ ;
sysdir set STBPLUS C:\STATA\ado\stbplus\ ;
capture log close;

foreach var in resid3  { ;
clear ;
gen a=. ;
save temp`var' , replace ; } ;

use b040305_b ;
sort hhold rd ;
tsset hhold rd ;
/* creating dummy variables */
quietly tab village , gen(v__v) ;
foreach X of numlist 2/12 { ; foreach Z of numlist 1/46 { ; qui gen v_d_`X'_`Z'=v__v`Z'*(rd==`X') ; } ; } ;
qui compress;


foreach var of varlist resid3 { ;

foreach x of numlist 3/12 { ;
foreach z of numlist 1/46 { ;
preserve ;
quietly keep if v_d_`x'_`z'==1 ;
global r `var' ;
quietly keep $r hhold rd ;
quietly drop if $r==. ;

capture mkmat $r hhold rd ;
capture mat define dif=$r*$r' ;
capture mat define hh1=hhold*J(1,_N,1) ;
capture mat define hh2=hh1' ;
capture mat define rdd=rd*J(1,_N,1) ;
local nn=colsof(dif) ;
local i 1 ; local j 1 ;
while `i'<=`nn' { ; while `j'<=`nn' { ;
if `i'>=`j' { ; mat dif[`i',`j']=0 ; } ;
local j=`j'+1 ; } ; local i=`i'+1 ; } ;
capture mat difr=vec(dif) ;
capture mat hh1r=vec(hh1) ;
capture mat hh2r=vec(hh2) ;
capture mat rdr=vec(rdd) ;
capture svmat difr ;
capture svmat hh1r ; 
capture svmat hh2r ;
capture svmat rdr ;
capture drop if difr1==0 ;
capture keep difr1 hh1r1 hh2r1 rdr1;
append using temp`var' ;
sort hh1r1 hh2r1 rdr1 ;
qui save temp`var' ,replace ;
restore ;
}; };
} ;
clear ;

foreach var in resid3 { ;
use temp`var' ;
rename hh1r1 hh1 ;
rename hh2r1 hh2 ;
rename rdr1 rd ;
rename difr1 dif`var' ;
compress ;
sort hh1 hh2 rd ; drop a ;
duplicates drop ;
save temp`var' ,replace ;
} ;



#delimit;
use b040305_b ;
sort hhold rd ;
merge hhold rd using rescons0501 ;
tab _merge ; drop _merge ;
sort hhold rd ;
save b040305bis_r, replace ;




#delimit;
use b040305bis_r ; rename hhold hh1 ; 

/*keep hh1 rd village lownedin rainfdin cirrigin wirrigin wastldin motldin 
lownedout rainfdou cirrigou wirrigou wastldou rinfxrt rinshrp roufxrt roushrp 
othexp foodexp nfoodexp agrincom income npers qinc  landnet resid resid2 res resid3;
*/




for X in any  
village    district   fill       agr        lf         l2f        landnet    pmdaysill
lowne      mill       npers      lnpers     lqinc      resid3     pfdaysill
rfdin      foodexp    qinc       resid      resid2     pqinc res 
/*
village lownedin rainfdin cirrigin wirrigin wastldin motldin 
lownedout rainfdou cirrigou wirrigou wastldou rinfxrt rinshrp roufxrt roushrp 
othexp foodexp nfoodexp agrincom income npers qinc  landnet resid resid2 res resid3
*/
: rename X X_1 ;
sort hh1 rd ; save tempb ,replace ;

#delimit;
use tempresid3 ;
sort hh1 rd ;
merge hh1 rd using tempb ; tab _merge ; keep if _merge==3 ; drop _merge ;
sort hh1 rd ;
qui compress;
save tempc , replace ;

use b040305bis_r ; rename hhold hh2 ; 

/*keep hh2 rd village lownedin rainfdin cirrigin wirrigin wastldin motldin 
lownedout rainfdou cirrigou wirrigou wastldou rinfxrt rinshrp roufxrt roushrp 
othexp foodexp nfoodexp agrincom income npers qinc  landnet resid resid2 res resid3;
*/

for X in any  
village    district   fill       agr        lf         l2f        landnet    pmdaysill
lowne      mill       npers      lnpers     lqinc      resid3     pfdaysill
rfdin      foodexp    qinc       resid      resid2     pqinc res 
/*
village lownedin rainfdin cirrigin wirrigin wastldin motldin 
lownedout rainfdou cirrigou wirrigou wastldou rinfxrt rinshrp roufxrt roushrp 
othexp foodexp nfoodexp agrincom income npers qinc  landnet resid resid2 res resid3
*/
: rename X X_2 ;
sort hh2 rd ; save tempb ,replace ;

use tempc ;
sort hh2 rd ;
merge hh2 rd using tempb ; tab _merge ; keep if _merge==3 ; drop _merge ;
sort hh2 rd ;
qui compress;
save tempc , replace ;

for X in any
village    district   fill       agr        lf         l2f        landnet    pmdaysill
lowne      mill       npers      lnpers     lqinc      resid3     pfdaysill
rfdin      foodexp    qinc       resid      resid2     pqinc res 
/*
village lownedin rainfdin cirrigin wirrigin wastldin motldin 
lownedout rainfdou cirrigou wirrigou wastldou rinfxrt rinshrp roufxrt roushrp 
othexp foodexp nfoodexp agrincom income npers qinc  landnet resid resid2 
*/
: gen dif_X=abs(X_1-X_2) ;
gen p_res=res_1*res_2;
egen vres_1=mean(res_1^2), by(hh1) ;
egen vres_2=mean(res_2^2), by(hh2) ;
gen pc_res=res_1*res_2/sqrt(vres_1*vres_2);

gen p_resid3=resid3_1*resid3_2;
egen vresid3_1=mean(resid3_1^2), by(hh1) ;
egen vresid3_2=mean(resid3_2^2), by(hh2) ;
gen pc_resid3=resid3_1*resid3_2/sqrt(vresid3_1*vresid3_2);
qui compress;

save tempc , replace ;

#delimit;
use tempc ;


xi :  reg pc_resid3  dif_lowne dif_rfdin dif_npers i.village_1*rd , r ;
xi :  reg pc_res  dif_lowne dif_rfdin dif_npers i.village_1*rd , r ;


