/*------------------------------------------------------------------------*/
/*  (dubois, jullien, magnac)  */
/*------------------------------------------------------------------------*/

#delimit ; 
set matsize 10000 ; set mem 200m ;
cd c:/pakistan/travail ;

clear ;

use b040305bis.dta ;
sort hhold rd ;
tsset hhold rd ;
compress ;

/* Predicting consumption residuals */
xi : reg lfoodexp l2f  lownedin rainfdin npers lnpers fdaysill mdaysill  qinc i.rd*i.village ;
outreg l2f  lnpers lownedin rainfdin npers fdaysill mdaysill  qinc using residcons, replace se nolabel ;
predict resid , r ;



/* For Table A1 and for predicting residuals corresponding to information controls */
xi : reg landnet lfoodexp  lownedin rainfdin npers lnpers i.rd*i.village , r ;
predict resid2 , r ;
outreg lfoodexp  lownedin rainfdin npers lnpers using landnet , replace se nolabel ;
xi : ivreg landnet (lfoodexp=l2f)  lownedin rainfdin npers lnpers i.rd*i.village , r ;
outreg lfoodexp  lownedin rainfdin npers lnpers using landnet , append se nolabel ;





/* creating dummy variables */
quietly tab village , gen(v__v) ;
foreach X of numlist 2/12 { ; foreach Z of numlist 1/46 { ; gen v_d_`X'_`Z'=v__v`Z'*(rd==`X') ; } ; } ;
compress;


/* profit equation */



/*  Robustness checks : with or without on farm labor income in profit */

gen agrincom2=agrincom-(daysmlb*wagem)/10000-(daysflb*wagef)/10000 ;
gen agrincom3=agrincom-(daysmlb*wagem)/10000 ;
gen agrincom4=agrincom-(daysflb*wagef)/10000 ;



*replace agrincom=agrincom4  ;  /* don't do this replace for agr income not including on farm labor income */


gen lllogtotcal=L.llogtotcal ;
reg llogtotcal lllogtotcal lownedin rainfdin npers lnpers fdaysill mdaysill  qinc v_d_* ;
predict residcal , r ;



/* Table 2 */
/* regressions in "comments" are not needed for Table 2 */

/*quietly reg agrincom  lfoodexp  lownedin rainfdin npers lnpers fdaysill mdaysill  qinc v_d_* , r ;
outreg lfoodexp  lnpers lownedin rainfdin npers fdaysill mdaysill  qinc using profit_equation , se replace nolabel ;
*/

quietly reg agrincom  lfoodexp resid  lownedin rainfdin npers lnpers fdaysill mdaysill  qinc v_d_* , r ;
outreg lfoodexp resid  lownedin rainfdin npers lnpers fdaysill mdaysill  qinc using profit_equation , se replace nolabel ;

/*quietly reg agrincom  lfoodexp resid2  lownedin rainfdin npers lnpers fdaysill mdaysill  qinc v_d_* , r ;
outreg lfoodexp resid2  lownedin rainfdin npers lnpers fdaysill mdaysill  qinc using profit_equation , se append nolabel ;
*/

quietly reg agrincom  lfoodexp resid resid2  lownedin rainfdin npers lnpers fdaysill mdaysill  qinc v_d_* , r ;
outreg lfoodexp resid resid2  lownedin rainfdin npers lnpers fdaysill mdaysill  qinc using profit_equation , se append nolabel ;
predict resid3 , r;

/*
quietly reg agrincom  llogkcalcap lfoodexp resid resid2  lownedin rainfdin npers lnpers fdaysill mdaysill  qinc v_d_* , r ;
outreg llogkcalcap lfoodexp resid resid2  lownedin rainfdin npers lnpers fdaysill mdaysill  qinc using profit_equation , se append nolabel ;


reg agrincom  lfoodexp  lownedin rainfdin npers lnpers fdaysill mdaysill  qinc v_d_* , r  ;
outreg lfoodexp  lownedin rainfdin npers lnpers fdaysill mdaysill  qinc using profit_equation , se append nolabel ;

reg agrincom  llogtotcal lfoodexp  lownedin rainfdin npers lnpers fdaysill mdaysill  qinc v_d_* , r  ;
outreg llogtotcal lfoodexp  lownedin rainfdin npers lnpers fdaysill mdaysill  qinc using profit_equation , se append nolabel ;

reg agrincom  llogtotcal residcal lfoodexp  lownedin rainfdin npers lnpers fdaysill mdaysill  qinc v_d_* , r  ;
outreg llogtotcal residcal lfoodexp  lownedin rainfdin npers lnpers fdaysill mdaysill  qinc using profit_equation , se append nolabel ;

reg agrincom  resid  llogtotcal residcal lfoodexp  lownedin rainfdin npers lnpers fdaysill mdaysill  qinc v_d_* , r  ;
outreg resid  llogtotcal residcal lfoodexp  lownedin rainfdin npers lnpers fdaysill mdaysill  qinc using profit_equation , se append nolabel ;

reg agrincom  resid2 llogtotcal residcal lfoodexp  lownedin rainfdin npers lnpers fdaysill mdaysill  qinc v_d_* , r  ;
outreg resid2 llogtotcal residcal lfoodexp  lownedin rainfdin npers lnpers fdaysill mdaysill  qinc using profit_equation , se append nolabel ;

reg agrincom  resid resid2 llogtotcal lfoodexp  lownedin rainfdin npers lnpers fdaysill mdaysill  qinc v_d_* , r  ;
outreg resid resid2 llogtotcal lfoodexp  lownedin rainfdin npers lnpers fdaysill mdaysill  qinc using profit_equation , se append nolabel ;
*/

reg agrincom  resid resid2 llogtotcal residcal lfoodexp  lownedin rainfdin npers lnpers fdaysill mdaysill  qinc v_d_* , r  ;
outreg resid resid2 llogtotcal residcal lfoodexp  lownedin rainfdin npers lnpers fdaysill mdaysill  qinc using profit_equation , se append nolabel ;
/*

reg agrincom  av_ad_bmi resid resid2 llogtotcal residcal lfoodexp  lownedin rainfdin npers lnpers fdaysill mdaysill  qinc v_d_* , r  ;
outreg av_ad_bmi resid resid2 llogtotcal residcal lfoodexp  lownedin rainfdin npers lnpers fdaysill mdaysill  qinc using profit_equation , se append nolabel ;
*/
reg agrincom  L.av_ad_bmi resid resid2 llogtotcal residcal lfoodexp  lownedin rainfdin npers lnpers fdaysill mdaysill  qinc v_d_* , r  ;
outreg L.av_ad_bmi resid resid2 llogtotcal residcal lfoodexp  lownedin rainfdin npers lnpers fdaysill mdaysill  qinc using profit_equation , se append nolabel ;
/*
reg agrincom  D.av_ad_bmi resid resid2 llogtotcal residcal lfoodexp  lownedin rainfdin npers lnpers fdaysill mdaysill  qinc v_d_* , r  ;
outreg D.av_ad_bmi resid resid2 llogtotcal residcal lfoodexp  lownedin rainfdin npers lnpers fdaysill mdaysill  qinc using profit_equation , se append nolabel ;
*/





/* predictions des chocs exogenes - fev 2005 */
#delimit;
sort hhold rd ;

reg fdaysill   lnpers npers	rainfdin lownedin L.foodexp resid2 resid 	v_d_* , r ;
outreg lnpers npers	rainfdin lownedin L.foodexp resid2 resid using pred_ex_shock , nolabel replace ;
predict pfdaysill , r ; 
reg mdaysill lnpers npers	rainfdin lownedin L.foodexp resid2 resid 	v_d_* , r ;
outreg lnpers npers	rainfdin lownedin L.foodexp resid2 resid  using pred_ex_shock , nolabel append ;
predict pmdaysill , r ; 
reg qinc  lnpers npers	rainfdin lownedin L.foodexp resid2 resid 	v_d_* , r ;
outreg lnpers npers	rainfdin lownedin L.foodexp resid2 resid 	 using pred_ex_shock , nolabel append ;
predict pqinc  , r ; 



qui compress ;



/* saving data for gauss program */


rename agrincom agr ;
rename lfoodexp  lf ;
rename lownedin lowne ;
rename rainfdin rfdin  ;
rename mdaysill mill ;
rename fdaysill fill ;


keep  village rd hhold district lowne rfdin fill mill foodexp agr npers qinc lf lnpers resid l2f lqinc resid2 landnet resid3 pqinc pmdaysill pfdaysill  ;

order  village rd hhold district lowne rfdin fill mill foodexp agr npers qinc lf lnpers resid l2f lqinc resid2 landnet resid3 pqinc pmdaysill pfdaysill  ;

save b040305_b , replace ;
